/* the biggie, a compiled RE (or rather, a front end to same) */
typedef struct
{
  /* the rest is opaque pointers to hidden innards */
  char       *re_guts;            /* `char *' is more portable than `void *' */
  char       *re_fns;
} regex_t;

/* function-pointer declarator */
#ifndef FUNCPTR
#define FUNCPTR(name, args) (*name) args
#endif

/*
 * table of function pointers for generic manipulation functions
 * A regex_t's re_fns points to one of these.
 */
struct fns
{
  void            FUNCPTR(free, (regex_t *));
};


/*
 * pg_regfree - free an RE (generic function, punts to RE-specific function)
 *
 * Ignoring invocation with NULL is a convenience.
 */
void
pg_regfree(regex_t *re)
{
  if (re == NULL)
    return;
  (*((struct fns *) re->re_fns)->free) (re);
}

int main()
{
  return 0;
}
