#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_fork_subchild_v1.c_v1_to_v2.hcupatch.so.2",2);


#define DEBUG 0
#if (DEBUG == 1)
#define dprintf(format, args...) printf(format, ##args)
#else
#define dprintf(format, args...) do {} while (0)
#endif

void run_the_child(void);
void run_the_subchild(void);
void run_the_parent(void);


int main()
{
  pid_t pid;

  pid = fork();
  if ( pid < 0 ) {
    printf("fork error: process cannot be forked\n");
    exit(1);
  } else if ( pid == 0 ) {
    // Child
    run_the_child();
  } else{
    // Parent process
    run_the_parent();
  }

  return 0;
}


void run_the_child(void)
{
  pid_t pid;

  dprintf("The child is running hcu\n");

  /* Fork a subchild */
  pid = fork();
  if ( pid < 0 ) {
    printf("fork error: subchild cannot be forked\n");
    exit(1);
  } else if ( pid == 0 ) {
    // Subchild
    run_the_subchild();
  } else {
    // Child
    int counter = 0;

    /* Wait indefinitely */
    while (1) {
      /* Sleep 0.1 seconds */
      usleep(100000);

      counter++;
      if (counter > 35) {
        exit(0);
      }
    }
  }


}



void run_the_subchild(void)
{
  int counter = 0;

  dprintf("The subchild is running hcu\n");

  /* Wait indefinitely */
  while (1) {
    /* Sleep 0.1 seconds */
    usleep(100000);

    counter++;
    if (counter > 25) {
      exit(0);
    }
  }
}



void run_the_parent(void)
{
  int counter = 0;
  dprintf("The parent is running hcu\n");

  /* Wait indefinitely */
  while (1) {
    /* Sleep 0.1 seconds */
    usleep(100000);

    counter++;
    if (counter == 15) {
      HCU_STATIC_REQUEST_UPDATE_IMMEDIATE();
    }

    if (counter > 25) {
      /* Be really sure that the children finished before we exit */
      sleep(3);
      exit(0);
    }
  }

}
