#include <stdlib.h>
#include <stdio.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_fork_wait_v1.c_v1_to_v2.hcupatch.so.2",2);


#define DEBUG 0
#if (DEBUG == 1)
#define dprintf(format, args...) printf(format, ##args)
#else
#define dprintf(format, args...) do {} while (0)
#endif

void run_the_child(void);
void run_the_parent(void);


int main()
{
  pid_t pid;

  pid = fork();
  if ( pid < 0 ) {
    printf("fork error: process cannot be forked\n");
    exit(1);
  } else if ( pid == 0 ) {
    // Child
    run_the_child();
  } else{
    // Parent process
    run_the_parent();
  }

  return 0;
}


void run_the_child(void)
{
  int counter = 0;
  dprintf("The child is running hcu\n");

  /* Wait indefinitely */
  while (1) {
    /* Sleep 0.1 seconds */
    usleep(100000);

    counter++;
    if (counter > 25) {
      exit(0);
    }
  }
}


void run_the_parent(void)
{
  int counter = 0;
  dprintf("The parent is running hcu\n");

  /* Wait indefinitely */
  wait(NULL);
  HCU_STATIC_REQUEST_UPDATE_IMMEDIATE();
  HCU_MANUAL_UPDATE_POINT();
}
