/* This file implements a group of threads executing the same code
   that competes for resources. For example, this could be a socket
   connection handler (e.g. serving database connections) */

#include <stdlib.h>
#include <pthread.h>
#include <sched.h>


#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_multithreaded_all_threads_nowrapper_v1.c_v1_to_v2.hcupatch.so.2",2);


#define DEBUG 0
#if (DEBUG == 1)
#define dprintf(format, args...) printf(format, ##args)
#else
#define dprintf(format, args...) do {} while (0)
#endif

void *thread_body(void *arg);


pthread_mutex_t lock;


int main()
{
  pthread_t thread_id;

  pthread_mutex_init(&lock, NULL);

  pthread_create(&thread_id, NULL, thread_body, NULL);
  pthread_create(&thread_id, NULL, thread_body, NULL);
  pthread_create(&thread_id, NULL, thread_body, NULL);
  pthread_create(&thread_id, NULL, thread_body, NULL);
  pthread_create(&thread_id, NULL, thread_body, NULL);

  while (1) {
    sleep(1);
  }

  return 0;
}


void exit_on_iterations(long iteration_counter, long max)
{
  if (iteration_counter >= max) {
    printf("iteration counter = %ld\n", iteration_counter);
    exit(0);
  }
}



void *thread_body(void *arg)
{
  long local_variable = 55555;
  long counter = 0;
  pthread_t thread_id;

  thread_id = pthread_self();
  while (1) {
    pthread_mutex_lock(&lock);
    counter++;
    exit_on_iterations(counter, 2);
    dprintf("HCU Thread %d using(%ld,%ld)...\n", thread_id, counter, local_variable);
    pthread_mutex_unlock(&lock);
    /* Sleep 0.1 seconds */
    usleep(100000);
    sched_yield();
    HCU_STATIC_REQUEST_UPDATE_IMMEDIATE();
  }
}
