typedef char bool;
typedef unsigned int size_t;
typedef size_t Size;
typedef unsigned int uint32;

enum NodeTag {
    T_Invalid = 0,
    T_IndexInfo = 10,
    T_ExprContext = 11,
    T_ProjectionInfo = 12,
    T_JunkFilter = 13,
    T_ResultRelInfo = 14,
    T_EState = 15,
    T_TupleTableSlot = 16,
    T_Plan = 100,
    T_Result = 101,
    T_Append = 102,
    T_Scan = 103,
    T_SeqScan = 104,
    T_IndexScan = 105,
    T_TidScan = 106,
    T_SubqueryScan = 107,
    T_FunctionScan = 108,
    T_Join = 109,
    T_NestLoop = 110,
    T_MergeJoin = 111,
    T_HashJoin = 112,
    T_Material = 113,
    T_Sort = 114,
    T_Group = 115,
    T_Agg = 116,
    T_Unique = 117,
    T_Hash = 118,
    T_SetOp = 119,
    T_Limit = 120,
    T_PlanState = 200,
    T_ResultState = 201,
    T_AppendState = 202,
    T_ScanState = 203,
    T_SeqScanState = 204,
    T_IndexScanState = 205,
    T_TidScanState = 206,
    T_SubqueryScanState = 207,
    T_FunctionScanState = 208,
    T_JoinState = 209,
    T_NestLoopState = 210,
    T_MergeJoinState = 211,
    T_HashJoinState = 212,
    T_MaterialState = 213,
    T_SortState = 214,
    T_GroupState = 215,
    T_AggState = 216,
    T_UniqueState = 217,
    T_HashState = 218,
    T_SetOpState = 219,
    T_LimitState = 220,
    T_Resdom = 300,
    T_Alias = 301,
    T_RangeVar = 302,
    T_Expr = 303,
    T_Var = 304,
    T_Const = 305,
    T_Param = 306,
    T_Aggref = 307,
    T_ArrayRef = 308,
    T_FuncExpr = 309,
    T_OpExpr = 310,
    T_DistinctExpr = 311,
    T_ScalarArrayOpExpr = 312,
    T_BoolExpr = 313,
    T_SubLink = 314,
    T_SubPlan = 315,
    T_FieldSelect = 316,
    T_RelabelType = 317,
    T_CaseExpr = 318,
    T_CaseWhen = 319,
    T_ArrayExpr = 320,
    T_CoalesceExpr = 321,
    T_NullIfExpr = 322,
    T_NullTest = 323,
    T_BooleanTest = 324,
    T_CoerceToDomain = 325,
    T_CoerceToDomainValue = 326,
    T_SetToDefault = 327,
    T_TargetEntry = 328,
    T_RangeTblRef = 329,
    T_JoinExpr = 330,
    T_FromExpr = 331,
    T_ExprState = 400,
    T_GenericExprState = 401,
    T_AggrefExprState = 402,
    T_ArrayRefExprState = 403,
    T_FuncExprState = 404,
    T_ScalarArrayOpExprState = 405,
    T_BoolExprState = 406,
    T_SubPlanState = 407,
    T_CaseExprState = 408,
    T_CaseWhenState = 409,
    T_ArrayExprState = 410,
    T_CoalesceExprState = 411,
    T_CoerceToDomainState = 412,
    T_DomainConstraintState = 413,
    T_RelOptInfo = 500,
    T_IndexOptInfo = 501,
    T_Path = 502,
    T_IndexPath = 503,
    T_NestPath = 504,
    T_MergePath = 505,
    T_HashPath = 506,
    T_TidPath = 507,
    T_AppendPath = 508,
    T_ResultPath = 509,
    T_MaterialPath = 510,
    T_UniquePath = 511,
    T_PathKeyItem = 512,
    T_RestrictInfo = 513,
    T_JoinInfo = 514,
    T_InnerIndexscanInfo = 515,
    T_InClauseInfo = 516,
    T_MemoryContext = 600,
    T_AllocSetContext = 601,
    T_Value = 650,
    T_List = 651,
    T_Integer = 652,
    T_Float = 653,
    T_String = 654,
    T_BitString = 655,
    T_Null = 656,
    T_Query = 700,
    T_InsertStmt = 701,
    T_DeleteStmt = 702,
    T_UpdateStmt = 703,
    T_SelectStmt = 704,
    T_AlterTableStmt = 705,
    T_AlterDomainStmt = 706,
    T_SetOperationStmt = 707,
    T_GrantStmt = 708,
    T_ClosePortalStmt = 709,
    T_ClusterStmt = 710,
    T_CopyStmt = 711,
    T_CreateStmt = 712,
    T_DefineStmt = 713,
    T_DropStmt = 714,
    T_TruncateStmt = 715,
    T_CommentStmt = 716,
    T_FetchStmt = 717,
    T_IndexStmt = 718,
    T_CreateFunctionStmt = 719,
    T_RemoveAggrStmt = 720,
    T_RemoveFuncStmt = 721,
    T_RemoveOperStmt = 722,
    T_RenameStmt = 723,
    T_RuleStmt = 724,
    T_NotifyStmt = 725,
    T_ListenStmt = 726,
    T_UnlistenStmt = 727,
    T_TransactionStmt = 728,
    T_ViewStmt = 729,
    T_LoadStmt = 730,
    T_CreateDomainStmt = 731,
    T_CreatedbStmt = 732,
    T_DropdbStmt = 733,
    T_VacuumStmt = 734,
    T_ExplainStmt = 735,
    T_CreateSeqStmt = 736,
    T_AlterSeqStmt = 737,
    T_VariableSetStmt = 738,
    T_VariableShowStmt = 739,
    T_VariableResetStmt = 740,
    T_CreateTrigStmt = 741,
    T_DropPropertyStmt = 742,
    T_CreatePLangStmt = 743,
    T_DropPLangStmt = 744,
    T_CreateUserStmt = 745,
    T_AlterUserStmt = 746,
    T_DropUserStmt = 747,
    T_LockStmt = 748,
    T_ConstraintsSetStmt = 749,
    T_CreateGroupStmt = 750,
    T_AlterGroupStmt = 751,
    T_DropGroupStmt = 752,
    T_ReindexStmt = 753,
    T_CheckPointStmt = 754,
    T_CreateSchemaStmt = 755,
    T_AlterDatabaseSetStmt = 756,
    T_AlterUserSetStmt = 757,
    T_CreateConversionStmt = 758,
    T_CreateCastStmt = 759,
    T_DropCastStmt = 760,
    T_CreateOpClassStmt = 761,
    T_RemoveOpClassStmt = 762,
    T_PrepareStmt = 763,
    T_ExecuteStmt = 764,
    T_DeallocateStmt = 765,
    T_DeclareCursorStmt = 766,
    T_A_Expr = 800,
    T_ColumnRef = 801,
    T_ParamRef = 802,
    T_A_Const = 803,
    T_FuncCall = 804,
    T_A_Indices = 805,
    T_ExprFieldSelect = 806,
    T_ResTarget = 807,
    T_TypeCast = 808,
    T_SortBy = 809,
    T_RangeSubselect = 810,
    T_RangeFunction = 811,
    T_TypeName = 812,
    T_ColumnDef = 813,
    T_IndexElem = 814,
    T_Constraint = 815,
    T_DefElem = 816,
    T_RangeTblEntry = 817,
    T_SortClause = 818,
    T_GroupClause = 819,
    T_FkConstraint = 820,
    T_PrivGrantee = 821,
    T_FuncWithArgs = 822,
    T_PrivTarget = 823,
    T_CreateOpClassItem = 824,
    T_CompositeTypeStmt = 825,
    T_InhRelation = 826,
    T_TriggerData = 900,
    T_ReturnSetInfo = 901
} ;
typedef enum NodeTag NodeTag;

struct MemoryContextData;
typedef struct MemoryContextData *MemoryContext;

struct MemoryContextMethods {
   void *(*alloc)(MemoryContext context , Size size ) ;
   void (*free_p)(MemoryContext context , void *pointer ) ;
   void *(*realloc)(MemoryContext context , void *pointer , Size size ) ;
   void (*init)(MemoryContext context ) ;
   void (*reset)(MemoryContext context ) ;
   void (*delete)(MemoryContext context ) ;
   Size (*get_chunk_space)(MemoryContext context , void *pointer ) ;
   void (*stats)(MemoryContext context ) ;
};
typedef struct MemoryContextMethods MemoryContextMethods;
struct MemoryContextData {
   NodeTag type ;
   MemoryContextMethods *methods ;
   MemoryContext parent ;
   MemoryContext firstchild ;
   MemoryContext nextchild ;
   char *name ;
};


struct HASHELEMENT {
   struct HASHELEMENT *link ;
   uint32 hashvalue ;
};
typedef struct HASHELEMENT HASHELEMENT;
typedef HASHELEMENT *HASHBUCKET;
typedef HASHBUCKET *HASHSEGMENT;

struct HASHHDR {
   long dsize ;
   long ssize ;
   int sshift ;
   uint32 max_bucket ;
   uint32 high_mask ;
   uint32 low_mask ;
   long ffactor ;
   long nentries ;
   long nsegs ;
   Size keysize ;
   Size entrysize ;
   long max_dsize ;
   HASHELEMENT *freeList ;
};


typedef struct HASHHDR HASHHDR;
struct HTAB {
   HASHHDR *hctl ;
   HASHSEGMENT *dir ;
   uint32 (*hash)(void const *key , Size keysize ) ;
   int (*match)(void const *key1 , void const *key2 , Size keysize ) ;
   void *(*alloc)(Size request ) ;
   MemoryContext hcxt ;
   char *tabname ;
   bool isshared ;
   void *(*keycopy)(void *dest , void const *src , Size keysize ) ;
};
typedef struct HTAB HTAB;


struct FSMHeader;
typedef struct FSMHeader FSMHeader;

struct FSMRelation;
typedef struct FSMRelation FSMRelation;

struct FSMHeader {
   HTAB *relHash ;
   FSMRelation *usageList ;
   FSMRelation *usageListTail ;
   FSMRelation *firstRel ;
   FSMRelation *lastRel ;
   int numRels ;
   double sumRequests ;
   char *arena ;
   int totalChunks ;
   int usedChunks ;
};

typedef unsigned int Oid;

struct RelFileNode {
   Oid tblNode ;
   Oid relNode ;
};
typedef struct RelFileNode RelFileNode;

struct FSMRelation {
   RelFileNode key ;
   FSMRelation *nextUsage ;
   FSMRelation *priorUsage ;
   FSMRelation *nextPhysical ;
   FSMRelation *priorPhysical ;
   bool isIndex ;
   Size avgRequest ;
   int lastPageCount ;
   int firstChunk ;
   int storedPages ;
   int nextPage ;
};

int main (void) {

  return 0;
}
