typedef long long filesize_t;

struct mystr {
   char *PRIVATE_HANDS_OFF_p_buf ;
   unsigned int PRIVATE_HANDS_OFF_len ;
   unsigned int PRIVATE_HANDS_OFF_alloc_bytes ;
};

struct vsf_session {
   unsigned long log_type ;
   long log_start_sec ;
   struct mystr remote_ip_str ;
   struct mystr log_str ;
   filesize_t transfer_size ;
   int is_ascii ;
   int is_anonymous ;
   struct mystr anon_pass_str ;
   struct mystr user_str ;
};

enum EVSFLogEntryType {
    kVSFLogEntryNull = 1,
    kVSFLogEntryDownload = 2,
    kVSFLogEntryUpload = 3,
    kVSFLogEntryMkdir = 4,
    kVSFLogEntryLogin = 5,
    kVSFLogEntryFTPInput = 6,
    kVSFLogEntryFTPOutput = 7,
    kVSFLogEntryConnection = 8
};

char const   *vsf_sysutil_get_current_date(void)
{
  return 0;
}

void str_alloc_text(struct mystr *p_str , char const   *p_src ) 
{
}

void str_append_str(struct mystr *p_str , struct mystr  const  *p_other ) 
{
}

void str_append_text(struct mystr *p_str , char const   *p_src ) 
{
}

void str_append_char(struct mystr *p_str , char the_char ) 
{
}

void str_append_ulong(struct mystr *p_str , unsigned long the_ulong )
{
}

void str_append_filesize_t(struct mystr *p_str , filesize_t the_filesize ) 
{
}

long vsf_sysutil_get_cached_time_sec(void) 
{
  return 0;
}

static void vsf_log_do_log_wuftpd_format(struct vsf_session *p_sess , struct mystr *p_str ,
                                         int succeeded ) 
{ long delta_sec ;
  enum EVSFLogEntryType what ;
  char const   *tmp ;
  long tmp___0 ;

  {
  what = (enum EVSFLogEntryType )p_sess->log_type;
  tmp = vsf_sysutil_get_current_date();
  str_alloc_text(p_str, tmp);
  str_append_char(p_str, (char )' ');
  tmp___0 = vsf_sysutil_get_cached_time_sec();
  delta_sec = tmp___0 - p_sess->log_start_sec;
  if (delta_sec <= 0L) {
    delta_sec = 1L;
  }
  str_append_ulong(p_str, (unsigned long )delta_sec);
  str_append_char(p_str, (char )' ');
  str_append_str(p_str, (struct mystr  const  *)(& p_sess->remote_ip_str));
  str_append_char(p_str, (char )' ');
  str_append_filesize_t(p_str, p_sess->transfer_size);
  str_append_char(p_str, (char )' ');
  str_append_str(p_str, (struct mystr  const  *)(& p_sess->log_str));
  str_append_char(p_str, (char )' ');
  if (p_sess->is_ascii) {
    str_append_text(p_str, "a ");
  } else {
    str_append_text(p_str, "b ");
  }
  str_append_text(p_str, "_ ");
  if ((int )what == 3) {
    str_append_text(p_str, "i ");
  } else {
    str_append_text(p_str, "o ");
  }
  if (p_sess->is_anonymous) {
    str_append_text(p_str, "a ");
    str_append_str(p_str, (struct mystr  const  *)(& p_sess->anon_pass_str));
  } else {
    str_append_text(p_str, "r ");
    str_append_str(p_str, (struct mystr  const  *)(& p_sess->user_str));
  }
  str_append_char(p_str, (char )' ');
  str_append_text(p_str, "ftp 0 * ");
  if (succeeded) {
    str_append_char(p_str, (char )'c');
  } else {
    str_append_char(p_str, (char )'i');
  }
  return;
}
}

int main()
{
  return 0;
}
