#include "hcu_headers.h"



__inline extern  __attribute__((__nothrow__)) unsigned long long gnu_dev_makedev(unsigned int __major ,
                                                                                 unsigned int __minor )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;
__inline extern  __attribute__((__nothrow__)) unsigned int gnu_dev_minor(unsigned long long __dev )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;
__inline extern  __attribute__((__nothrow__)) unsigned int gnu_dev_major(unsigned long long __dev )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;



extern int unsortedNumbers[];
extern int unsortedNumbersSize;



void printNumbers(int numbers[], int array_size) HCU_NON_LIBRARY_FUNCTION;


void selectionSort(int *numbers, int array_size)
{
  int i, j;
  int min, temp;
  int resumed = 0;

  printf("Running selectionSort from the beginning with array_size %ld\n", array_size);

  for (i = 0; i < array_size-1; i++)
  {
    min = i;
    for (j = i+1; j < array_size; j++)
    {
      if (resumed == 0) {
        printf("Running selectionSort from the middle of a nested loop with array_size %ld\n", array_size);
        resumed = 1;
      }

      if (numbers[j] < numbers[min])
        min = j;
    }
    temp = numbers[i];
    numbers[i] = numbers[min];
    numbers[min] = temp;
  }
}

struct hcu_stack_local_bubbleSort_v1_s {
   int i ;
   int j ;
   int temp ;
   hcu_stack_trace_t *hcu_stack_trace_var;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_stack_local_selectionSort_v2_s {
   int i ;
   int j ;
   int min ;
   int temp ;
   int resumed ;
   hcu_stack_trace_t *hcu_stack_trace_var;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_bubbleSort_v1_s {
   int *numbers ;
   int array_size ;
};

struct hcu_function_formal_selectionSort_v2_s {
   int *numbers ;
   int array_size ;
};


void HCU_stack_transformer__selectionSort(void *transform_stack_to, void *transform_stack_from, void *transform_params_to) HCU_NON_UPDATEABLE;
void HCU_stack_transformer__selectionSort(void *transform_stack_to, void *transform_stack_from, void *transform_params_to)
{
  struct hcu_stack_local_selectionSort_v2_s *stack_to;
  struct hcu_stack_local_bubbleSort_v1_s *stack_from;
  struct hcu_function_formal_selectionSort_v2_s *params_to;

  stack_to = (struct hcu_stack_local_selectionSort_v2_s *) transform_stack_to;
  stack_from = (struct hcu_stack_local_bubbleSort_v1_s *) transform_stack_from;
  params_to = (struct hcu_function_formal_selectionSort_v2_s *) transform_params_to;

  /* Continue the selectionsort algorithm from the current iteration (redo
     the last iteration); from where we left off. Don't restart it from
     scratch. */

  /* Our bubbleSort implementation processes an array from the
     end. Thus we simple have to shrink the array size to define the
     new bounds of the array for the selectionsort. */
  params_to->array_size = stack_from->i + 1;
  hcu_copy_stack_frame_fields(&stack_to->hcu_stack_frame_fields,&stack_from->hcu_stack_frame_fields);
  stack_to->hcu_stack_trace_var = stack_from->hcu_stack_trace_var;
  stack_to->i = 0;
  stack_to->j = 1;
  stack_to->min = 0;
  stack_to->resumed = 0;
}



int hcu_wrapped_main(void) HCU_NEW_VERSION;
int hcu_wrapped_main(void)
{
  int array_size  = unsortedNumbersSize;

  selectionSort(unsortedNumbers, array_size);
  printNumbers(unsortedNumbers, array_size);

  return 0;
}


hcu_mapping_execution_continuation_t mappings_v2[] = { { 2, 3 } };
long mappings_size_v2 = 1;

int HCU_update_description_function(void) HCU_NON_UPDATEABLE;
int HCU_update_description_function(void)
{
  hcu_set_update_description("main","main");
  hcu_set_algorithmic_equivalence("bubbleSort","selectionSort", &mappings_v2, mappings_size_v2);
  printf("HCU_update_description_function_v2 executed\n");

  return 0;
}



extern int (*hcu_indirection_pointer__hcu_wrapped_main)(void) HCU_NEW_VERSION ;
int HCU_function_updates_function(void) HCU_NON_UPDATEABLE;
int HCU_function_updates_function(void)
{
  hcu_indirection_pointer__hcu_wrapped_main = &hcu_wrapped_main;
  printf("HCU_function_updates_function_v2 executed\n");

  return 0;
}



int HCU_datatype_transformations_function(void) HCU_NON_UPDATEABLE;
int HCU_datatype_transformations_function(void)
{
  printf("HCU_datatype_transformations_function_v2 executed\n");

  return 0;
}
